package cz.zweistein.df.soundsense.player;

import java.util.logging.Logger;

import cz.zweistein.df.soundsense.config.MusicLoop;
import cz.zweistein.df.soundsense.config.Sound;
import cz.zweistein.df.soundsense.util.LoggerSource;


public class PlayerManager {
	private static Logger logger = LoggerSource.logger;
	
	private PlayerThread musicThread;
	public int concurentSounds;
	
	public PlayerManager() {
		this.musicThread = new PlayerThread();
		new Thread(musicThread).start();
		this.concurentSounds = 0;
	}

	public void playSound(Sound sound) {
		
		if (sound.getMusic() == false) {
			if (sound.getConcurency() == null || (sound.getConcurency() != null && concurentSounds < sound.getConcurency())) {
				MP3Thread mp3Thread = new MP3Thread(this, sound.getSoundFile());
				new Thread(mp3Thread).start();
			} else {
				logger.fine("Dropped sound for "+sound.getLogPattern()+" its concurency is "+sound.getConcurency()+" and there are "+concurentSounds+" sounds playing.");
			}
		} else  {
			if (sound.getLoop() == MusicLoop.START_LOOPING) {
				musicThread.setLoopMusic(sound);
			} else if (sound.getLoop() == MusicLoop.STOP_LOOPING) {
				musicThread.setLoopMusic(null);
				logger.fine("Stopped looping music.");
			}
			musicThread.setCurrentMusic(sound.getSoundFile());
			musicThread.setTemporaryLoopDisable(true);
				
			if (musicThread.getMusicPlayer() != null) {
				musicThread.getMusicPlayer().close();
			}
		}
		
	}

}
